Attribute VB_Name = "Module1"
'TGA Image Viewer for Visual Basic 6.0

'Copyright 2003 by Dmitry Brant, All Rights Reserved.

'Version 1.1, Last modified 04-27-2000
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'This program supports the TGA specification as described below:

'- This program fully supports alpha channels.

'- This program only supports 8-bit color maps. It also
'  does not support Huffman-compressed color maps.

'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Private Type TGAHeader
   LengthOfField As Byte
   ColorMap As Byte
   ImageType As Byte
   OffsetOfColorMap As Integer
   ColorsUsed As Integer
   BitsPerColorMap As Byte
   XCoordinate As Integer
   YCoordinate As Integer
   ImageWidth As Integer
   ImageHeight As Integer
   BitsPerPixel As Byte
   Flags As Byte
End Type

Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

Public Sub DoTGA(FName As String, FObject As Object)
    Dim TGAHeader As TGAHeader, str1 As String, theHdc As Long
    Dim BitsPerPixel As Integer, BytesPerPixel As Integer, ImageType As Integer
    Dim i As Integer, j As Integer, k As Integer
    Dim r As Integer, g As Integer, b As Integer, n As Integer, a As Integer
    Dim x As Integer, y As Integer, z As Integer

    On Error GoTo ErrorTrap0:
    
    Open FName For Binary As #1

    str1 = ""
    theHdc = FObject.hdc
    
    Get #1, , TGAHeader
    If TGAHeader.LengthOfField <> 0 Then str1 = Space(TGAHeader.LengthOfField)
    If TGAHeader.ColorMap > 1 Then
        Close #1
        MsgBox "This is not a valid TGA file.", vbCritical, "Error"
        Exit Sub
    End If
    
    BitsPerPixel = TGAHeader.BitsPerPixel
    ImageType = TGAHeader.ImageType

    Select Case ImageType
        Case 0 'No Image Data Available
        Case 1 'Uncompressed Color Image
        Case 2 'Uncompressed RGB Image
        Case 3 'Uncompressed Black & White Image
        Case 9 'Compressed Color Image
        Case 10 'Compressed RGB Image
        Case 11 'Compressed Black & White Image
    End Select

    Get #1, , str1

    If ImageType = 3 Or ImageType = 11 Or ImageType = 32 Or ImageType = 33 Then
        MsgBox "This image type is not supported.", vbCritical, "Error"
        Close #1
        Exit Sub
    ElseIf TGAHeader.BitsPerPixel <> 8 And TGAHeader.BitsPerPixel <> 16 And TGAHeader.BitsPerPixel <> 24 And TGAHeader.BitsPerPixel <> 32 Then
        MsgBox "We only support 8, 16, 24, and 32 bits per pixel.", vbCritical, "Error"
        Close #1
        Exit Sub
    End If

    If ImageType = 1 Or ImageType = 9 Then
        ReDim Palette(0 To (2 ^ BitsPerPixel) - 1) As Long
        For i = 0 To (2 ^ BitsPerPixel) - 1
            b = GetByte
            g = GetByte
            r = GetByte
            Palette(i) = RGB(r, g, b)
        Next i
    End If

    If ImageType = 1 Or ImageType = 2 Then
        ReDim Scanline(0 To TGAHeader.ImageWidth * (BitsPerPixel \ 8) - 1) As Byte
        For y = TGAHeader.ImageHeight - 1 To 0 Step -1
            If BitsPerPixel = 8 Then
                Get #1, , Scanline
                For x = 0 To TGAHeader.ImageWidth - 1
                    SetPixel theHdc, x, y, Palette(Scanline(x))
                Next x
            ElseIf BitsPerPixel = 16 Then
                For x = 0 To TGAHeader.ImageWidth - 1
                    j = GetByte 'hi byte
                    k = GetByte 'lo byte
                    r = (k And 127) \ 4
                    g = (k And 3) * 8 + ((j And &HE0) \ 32)
                    b = j And 31
                    SetPixel theHdc, x, y, RGB(r * 8, g * 8, b * 8)
                Next x
            ElseIf BitsPerPixel = 24 Then
                Get #1, , Scanline
                For x = 0 To TGAHeader.ImageWidth - 1
                    b = Scanline(x * 3)
                    g = Scanline(x * 3 + 1)
                    r = Scanline(x * 3 + 2)
                    SetPixel theHdc, x, y, RGB(r, g, b)
                Next x
            ElseIf BitsPerPixel = 32 Then
                Get #1, , Scanline
                For x = 0 To TGAHeader.ImageWidth - 1
                    b = Scanline(x * 4)
                    g = Scanline(x * 4 + 1)
                    r = Scanline(x * 4 + 2)
                    a = Scanline(x * 4 + 3)
                    SetPixelA theHdc, x, y, r, g, b, a
                Next x
            Else
                Exit Sub
            End If
            If y Mod 32 = 0 Then FObject.Refresh: DoEvents
        Next y
        Erase Scanline
        Erase Palette
    ElseIf ImageType = 9 Or ImageType = 10 Then
        y = TGAHeader.ImageHeight - 1
        x = 0
        str1 = " "
        BytesPerPixel = BitsPerPixel \ 8
        Do
            i = GetByte
            Select Case i
                Case 0 To 127:
                    If BitsPerPixel = 8 Then
                        ReDim Scanline(0 To (i + 1) * BytesPerPixel - 1) As Byte
                        Get #1, , Scanline
                        For j = 0 To i
                            SetPixel theHdc, x, y, Palette(Scanline(j))
                            x = x + 1
                        Next j
                    ElseIf BitsPerPixel = 16 Then
                        For z = 0 To i
                            j = GetByte 'hi byte
                            k = GetByte 'lo byte
                            r = (k And 127) \ 4
                            g = (k And 3) * 8 + ((j And &HE0) \ 32)
                            b = j And 31
                            SetPixel theHdc, x, y, RGB(r * 8, g * 8, b * 8)
                            x = x + 1
                        Next z
                    ElseIf BitsPerPixel = 24 Then
                        ReDim Scanline(0 To (i + 1) * BytesPerPixel - 1) As Byte
                        Get #1, , Scanline
                        For j = 0 To i
                            b = Scanline(j * 3)
                            g = Scanline(j * 3 + 1)
                            r = Scanline(j * 3 + 2)
                            SetPixel theHdc, x, y, RGB(r, g, b)
                            x = x + 1
                        Next j
                    ElseIf BitsPerPixel = 32 Then
                        ReDim Scanline(0 To (i + 1) * BytesPerPixel - 1) As Byte
                        Get #1, , Scanline
                        For j = 0 To i
                            b = Scanline(j * 4)
                            g = Scanline(j * 4 + 1)
                            r = Scanline(j * 4 + 2)
                            a = Scanline(j * 4 + 3)
                            SetPixelA theHdc, x, y, r, g, b, a
                            x = x + 1
                        Next j
                    End If
                Case 128
                Case Else
                    n = i And 127
                    If BitsPerPixel = 8 Then
                        FObject.Line (x, y)-Step(n + 1, 0), Palette(GetByte)
                        x = x + n + 1
                    ElseIf BitsPerPixel = 16 Then
                        j = GetByte 'hi byte
                        k = GetByte 'lo byte
                        r = (k And 127) \ 4
                        g = (k And 3) * 8 + ((j And &HE0) \ 32)
                        b = j And 31
                        FObject.Line (x, y)-Step(n + 1, 0), RGB(r * 8, g * 8, b * 8)
                        x = x + n + 1
                    ElseIf BitsPerPixel = 24 Then
                        b = GetByte
                        g = GetByte
                        r = GetByte
                        FObject.Line (x, y)-Step(n + 1, 0), RGB(r, g, b)
                        x = x + n + 1
                    ElseIf BitsPerPixel = 32 Then
                        b = GetByte
                        g = GetByte
                        r = GetByte
                        a = GetByte
                        For j = 0 To n
                            SetPixelA theHdc, x + j, y, r, g, b, a
                        Next j
                        x = x + n + 1
                    End If
                End Select
            If x >= TGAHeader.ImageWidth Then
                x = 0: y = y - 1
                If y Mod 32 = 0 Then DoEvents: FObject.Refresh
            End If
            If y < 0 Then Exit Do
        Loop
        Erase Scanline
        Erase Palette
    End If
    str1 = ""
    Close #1
    Exit Sub
    
ErrorTrap0:
    Close #1
    MsgBox "There was an error reading the file:" + vbCrLf + Error$, vbCritical, "Error"
End Sub

Function GetByte() As Integer
    Dim a As Byte
    Get #1, , a
    GetByte = a
End Function

'Set an alpha-pixel
Sub SetPixelA(dc As Long, x1 As Integer, y1 As Integer, r1 As Integer, g1 As Integer, b1 As Integer, a1 As Integer)
    Dim col2 As Long, r As Integer, g As Integer, b As Integer, diff As Integer
    col2 = GetPixel(dc, x1, y1)
    b = (col2 \ 65536) And &HFF
    g = (col2 \ 256) And &HFF
    r = col2 And &HFF
    diff = CLng(b1 - b) * a1 / 256
    b = b + diff
    diff = CLng(g1 - g) * a1 / 256
    g = g + diff
    diff = CLng(r1 - r) * a1 / 256
    r = r + diff
    SetPixel dc, x1, y1, RGB(r, g, b)
End Sub

